require "dbcommit/version"
require 'term/ansicolor'



module Dbcommit

  IMPERATIVE = ["add", "reformat", "style", "create", "delete", "change", "modify", "update", "replace", "minimize", "make", "implement", "compare", "test", "refresh", "clean", "get", "post", "compute", "describe", "document", "comment", "improve", "check", "close", "include", "provide", "insert", "read", "switch", "swap", "fix", "import", "export", "present", "set", "do", "undo", "schedule", "filter", "run", "prevent", "note", "transpose", "give", "open", "destroy", "require", "develop", "raise", "split", "join", "load", "unload", "review", "view", "control", "model", "mix", "submit", "code", "clear", "structure", "refactor", "count", "validate", "install", "clone", "lock", "store", "convert", "write", "find", "pull", "push", "request", "authenticate", "show", "prove", "migrate", "route", "define", "print", "hit", "save", "advance", "start", "begin", "end", "finish", "format", "send", "receive", "kill", "generate", "correct", "rename", "log", "map", "inspect", "associate", "search", "collect", "select", "reject", "merge", "combine", "compact", "concat", "cycle", "drop", "truncate", "fetch", "fill", "flatten", "freeze", "initialize", "copy", "pack", "permute", "pop", "repeat", "reverse", "rotate", "sample", "sort", "order", "shift", "shuffle", "slice", "take", "execute", "randomize", "detect", "group", "reduce", "inject", "zip", "sum", "divide", "multiply", "use", "restore", "subtract", "exponentiate", "return", "iterate", "recurse", "exit", "commit", "message", "punctuate", "hold", "uninstall", "accept", "contribute", "command", "try", "move", "base", "rebase", "enter", "leave", "finalize", "penalize", "unify", "pass", "allow", "let", "disable", "enable", "ignore", "target", "skip", "perform", "build", "scaffold", "reassign", "bring", "preserve", "assert", "name", "redefine", "deprecate", "introduce", "go", "expand", "mutate", "rely", "duplicate", "extract", "render", "assign", "rewrite", "call", "bind", "unbind", "affect", "escape", "calculate", "bundle", "eliminate", "specify", "guide", "stop", "digest", "relax", "readd", "disallow", "regenerate", "fork", "persist", "rollback", "reset", "simplify", "prefer", "demonstrate", "better", "avoid", "consider", "throw", "loosen", "support", "cleanup", "revert", "integrate", "verify", "share", "ensure", "condense", "rephrase", "un-inline", "adjust", "inform", "fall", "fallback", "cast", "reuse", "propagate", "dump", "list", "clarify", "warn"]

  CURSES = ["arse", "ass", "asshole", "bastard", "bitch", "bollocks", "bloody", "child-fucker", "cunt", "damn", "fuck", "goddamn", "godsdamn", "hell", "holy shit", "motherfucker", "shit", "shite", "shitass", "son of a bitch", "son of a whore", "twat", "fucker", "cock", "dick", "fucking"]

  PUNCTUATION = [".", ",", "!", "?"]

  private
    def self.check_length_of_message(message)
      case message.length
      when 0..10
        print "* Commit message size: Too short: #{message.length} characters.".yellow, "\n"
      when 11..51
        print "* Commit message size: Perfect: #{message.length} characters.".green, "\n"
      when 51..100
        print "* Commit message size: Too long: #{message.length} characters.".red, "\n"
      else
        print "* Commit message size: Gingantic: #{message.length} characters.".red, "\n"
      end
    end

    def self.check_capitalized_first_word(message)
      if message[0] != message[0].upcase
        print "* Always begin your commit message with a capital letter of.".red, "\n"
      end
    end

    def self.check_tense_of_message(message)
      if !IMPERATIVE.include?(message.split[0].downcase)
        print "* Commit message was not written in the correct gramatical mood: #{message.split[0]}".red, "\n"
        print '* Your commit messages should be in the "Imperative" mood.'.blue, "\n"
      end
    end

    def self.check_conjunctions_in_message(message)
      message.split.each do |word|
        if word.downcase == "and"
          print '* Never use "and" in your commit message simply make a separate commit."'.red, "\n"
        end
      end
    end

    def self.check_if_message_ends_with_period(message)
      if PUNCTUATION.include?(message[-1])
        print "* First line of commit message should never include ending punctuation.".red, "\n" 
        print "* You ended your message with a #{message[-1]}".red, "\n"
      end
    end

    def self.check_cursing_in_message(message)
      message.split.each do |word|
        if CURSES.include?(word.downcase)
          print "* Your should never swear in your commit messages!".red, "\n"
        end
      end
    end

    def self.check_number_of_files(files)
      case files
      when 1
        print "* Number of files changed: Perfect: #{files} file(s)".green, "\n"
      when 2
        print "* Number of files changed: Good: #{files} file(s)".blue, "\n"
      when 3
        print "* Number of files changed: Okay: #{files} file(s)".yellow, "\n"
      when 4
        print "* Number of files changed: Marginal: #{files} file(s)".orange, "\n"
      when 5
        print "* Number of files changed: Bad: #{files} file(s)".red, "\n"
      else
        print "* Number of files changed: Terrble: #{files} file(s)".red, "\n"
      end
    end

    def self.check_number_of_changes(changes)
      case changes
      when 1..11
        print "* Number of changes: Perfect: #{changes} change(s)".green, "\n"
      when 12..30
        print "* Number of changes: Okay: #{changes} change(s)".yellow, "\n"
      when 31..60
        print "* Number of changes: Too many: #{changes} change(s)".orange, "\n"
      else
        print "* Number of changes: Way too many: #{changes} change(s)".red, "\n"
    end
  end
end

class String 
  include Term::ANSIColor
end
